#!--------------------------------------------------------------------------
#! (c) 1996 thru 2005 by
#! Tinman Development Corporation
#!                And
#! Reichenberger Development Incorporated
#! All Rights Reserved World Wide
#! ISBN: 0-933735-16-2
#! 
#!--------------------------------------------------------------------------
#TEMPLATE(TagingABC, 'Taging Templates'),Family('ABC')
#!--------------------------------------------------------------------------
#! Tag Template For ABC Browse
#!--------------------------------------------------------------------------
#CONTROL(TagBrowseABC,'(TAG) For ABC Browse'),DESCRIPTION('(TAG) Tagging on ' & %Primary),REQ(BrowseBox(ABC)),FIRST,HLP('Browse Extension Template')
  CONTROLS
    BUTTON(''),AT(,,20,13),USE(?TAG) ,ICON('tagone.ico'),MSG('Tag')
    BUTTON(''),AT(,,20,13),USE(?TAGAll) ,ICON('tagall2.ico'),MSG('TagAll')
    BUTTON(''),AT(,,20,13),USE(?UNTAGALL) ,ICON('untagal2.ico'),MSG('UnTagAll')
    BUTTON(''),AT(,,20,13),USE(?REVTAG) ,ICON('fliprest.ico'),MSG('RevTag')
    BUTTON(''),AT(,,50,13),USE(?SHOWTAG),MSG('ShowTag')
  END
#SHEET
#TAB('General')
  #PROMPT('File Name:',File),%TAGFILE
  #PROMPT('Use for selection:',DROP('Pointer|Position|Key')),%TAGUSETYPE,DEFAULT('Key')
  #PROMPT('Save To Queue Name:',FROM(%GlobalData,(INSTRING('QUEUE',%GlobalDataStatement,1,1)),%GlobalData)),%TAGQUEUENAME,DEFAULT('')
  #ENABLE(%TAGUSETYPE <> 'Key')
   #PROMPT('Save To Queue Field:',FROM(%GlobalData,(~INSTRING('QUEUE',%GlobalDataStatement,1,1)),%GlobalData)),%TAGQUEUEFIELD,DEFAULT('')
  #ENDENABLE
  #ENABLE(NOT %TAGRESTOREENTRY AND NOT %TAGSAVEEXIT)
  #PROMPT('Clear Tags On Entry ',CHECK),%TAGCLEARENTRY,DEFAULT('0'),AT(10)
  #PROMPT('Clear Tags On Exit  ',CHECK),%TAGCLEAREXIT,DEFAULT('0'),AT(10)
  #ENDENABLE
  #ENABLE(NOT %TAGCLEARENTRY AND NOT %TAGCLEAREXIT)
  #PROMPT('Restore Tags On Entry ',CHECK),%TAGRESTOREENTRY,DEFAULT('0'),AT(10)
  #PROMPT('Save Tags On Exit  ',CHECK),%TAGSAVEEXIT,DEFAULT('0'),AT(10)
  #ENDENABLE
#ENDTAB
#TAB('Key'),WHERE(%TAGUSETYPE = 'Key'),CLEAR
  #PROMPT('Key ',KEY(%TAGFILE)),%TAGFILEKEY
  #BUTTON('Key Fields '),MULTI(%TAGKEYFIELDS,%TAGKEYFIELD & ' - ' & %TAGKEYQUEUEFIELD),HLP('~TAGgin'),INLINE
     #PROMPT('Key Field: ',COMPONENT(%TAGFILEKEY)),%TAGKEYFIELD
     #PROMPT('Save To Queue Field:',FROM(%GlobalData,(~INSTRING('QUEUE',%GlobalDataStatement,1,1)),%GlobalData)),%TAGKEYQUEUEFIELD,DEFAULT('')
  #ENDBUTTON
#ENDTAB
#TAB('Tag Display')
    #DISPLAY
    #PROMPT('Tag Field:',FROM(%LocalData)),%TAGDISPLAYFIELD,DEFAULT('')
    #PROMPT('Tag Character:',@S1),%TAGDISPLAYCHAR,REQ,DEFAULT('*')
    #DISPLAY
    #PROMPT('Allow space bar for tagging',CHECK),%TAGALLOWSPACEBAR,AT(10,,180),DEFAULT(1)
    #DISPLAY
    #PROMPT('Allow Mouse tagging',CHECK),%TAGALLOWMOUSE,AT(10,,180)
    #DISPLAY
    #PROMPT('Scroll down after tagging',CHECK),%TAGSCROLLDOWNAFTER,AT(10,,180)
    #DISPLAY
    #PROMPT('Refresh Window after each tag operation',CHECK),%TAGREFRESHWINDOW,AT(10,,180)
    #DISPLAY
    #PROMPT('Allow Tagging Via Popup',CHECK),%TAGALLOWPOPUP,AT(10,,180)
    #DISPLAY
    #BOXED('Button Text While Displaying')
    #PROMPT('All Records:',@S30),%TAGShowAll,DEFAULT('')
    #PROMPT('Tagged Records:',@S30),%TAGShowTag,DEFAULT('')
    #PROMPT('Untagged Records:',@S30),%TAGShowUnTag,DEFAULT('')
    #ENDBOXED
#ENDTAB
#TAB('Tag Status')
    #PROMPT('Field For Tag Count:',FIELD),%TAGCOUNT,DEFAULT('')
    #PROMPT('Field For Tag Change:',FIELD),%TAGCHANGE,DEFAULT('')
#ENDTAB
#TAB('Tag File'),WHERE(%TAGRESTOREENTRY OR %TAGSAVEEXIT)
    #PROMPT('File Name:',File),%TAGSAVEFILENAME
    #PROMPT('Tag Key:',KEY(%TAGSAVEFILENAME)),%TAGSAVEFILEKEY
    #PROMPT('Key ID Field: ',COMPONENT(%TAGSAVEFILEKEY)),%TAGSAVEFILEKEYIDFIELD
    #PROMPT('Tag ID Field:',FIELD),%TAGSAVEIDFIELD,DEFAULT('')
    #ENABLE(%TAGSAVEEXIT)
    #PROMPT('Stream Tag Save',CHECK),%TAGSAVESTREAM,AT(10)
    #PROMPT('Clear Tag Queue After Save',CHECK),%TAGSAVECLEAR,AT(10)
    #ENDENABLE
    #BUTTON('Fields:'),MULTI(%TAGSAVEFILEFIELDS,%TAGSAVEFILEQUEUEFIELD & ' - ' & %TAGSAVEFILEFIELD),HLP('~TAGgin'),INLINE
    #PROMPT('File Field: ',FIELD(%TAGSAVEFILENAME)),%TAGSAVEFILEFIELD
    #PROMPT('Save Queue Field:',FROM(%GlobalData,(~INSTRING('QUEUE',%GlobalDataStatement,1,1)),%GlobalData)),%TAGSAVEFILEQUEUEFIELD,DEFAULT('')
    #ENDBUTTON
#ENDTAB
#ENDSHEET
#!-----------------------------------------------------------
#ATSTART
#DECLARE(%TAGVALUECONST)
#DECLARE(%TAGListInstance)
#SET(%TAGListInstance,%ActiveTemplateParentInstance)
#DECLARE(%TAGBROWSEPREFIX)
#DECLARE(%BROWSECTRL)
#SET(%TAGBROWSEPREFIX,'DBRW::' & %ActiveTemplateInstance)
#!FOR(%CONTROL),WHERE(%ControlInstance=%ActiveTemplateParentInstance)
#!SET(%BROWSECTRL,%CONTROL)
#!ENDFOR
#CALL(%GROUPFINDPARENTCONTROL),%BROWSECTRL
#DECLARE(%TAGCONTROLNUM)
#DECLARE(%TAQWORKQUE)
#SET(%TAQWORKQUE,CLIP(%TAGBROWSEPREFIX) & ':QUEUE')
#DECLARE(%SHOWTAG)
#DECLARE(%RevAllTag)
#DECLARE(%TAGCONTROL)
#DECLARE(%TAGCONTROLTEXT)
#DECLARE(%TAGAllCONTROL)
#DECLARE(%TAGAllCONTROLTEXT)
#DECLARE(%UNTAGALLCONTROL)
#DECLARE(%UNTAGALLCONTROLTEXT)
#DECLARE(%REVTAGCONTROL)
#DECLARE(%REVTAGCONTROLTEXT)
#DECLARE(%SHOWTAGCONTROL)
#DECLARE(%SHOWTAGCONTROLTEXT)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?SHOWTAG')
      #SET(%SHOWTAG,1)
      #SET(%SHOWTAGCONTROL,%Control)
    #OF('?TAGAll')
      #SET(%TAGAllCONTROL,%Control)
      #SET(%RevAllTag,1)
    #OF('?REVTAG')
      #SET(%REVTAGCONTROL,%Control)
      #SET(%RevAllTag,1)
    #OF('?TAG')
      #SET(%TAGCONTROL,%Control)
    #OF('?UNTAGALL')
      #SET(%UNTAGALLCONTROL,%Control)
    #ENDCASE
  #ENDFOR
#DECLARE(%TAGGACTQUEUEFIELDS)
#DECLARE(%TAGGWRKQUEUEFIELDS)
  #INSERT(%TAGBUILDKEYSTRING,'B')
  #!%ManagerName.
#ENDAT
#!--------------------------------------------------------------------------
#! Tagging Data
#!--------------------------------------------------------------------------
#AT(%DataSection),LAST
#INSERT(%TAGDATAGROUP)
#ENDAT
#!--------------------------------------------------------------------------
#! Tagging Init
#!--------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),LAST
#INSERT(%TAGINITGRP)
#IF(%TAGALLOWSPACEBAR)
%ListControl{Prop:Alrt,239} = SpaceKey
#!%ListControl{PROP:Alrt,238} = MouseRight
#ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#! Tagging Popup
#!--------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9500),Where(%TAGALLOWPOPUP)
    #SUSPEND
#?%ManagerName.Popup.AddItem('-','TAGSeparator')
    #IF(%TAGCONTROL)
%ManagerName.Popup.AddItemEvent('',EVENT:Accepted,%TAGCONTROL)
    #ENDIF
    #IF(%TAGAllCONTROL)
%ManagerName.Popup.AddItemEvent(' ',EVENT:Accepted,%TAGAllCONTROL)
    #ENDIF
    #IF(%UNTAGALLCONTROL)
%ManagerName.Popup.AddItemEvent('  ',EVENT:Accepted,%UNTAGALLCONTROL)
    #ENDIF
    #IF(%REVTAGCONTROL)
%ManagerName.Popup.AddItemEvent(' ',EVENT:Accepted,%REVTAGCONTROL)
    #ENDIF
    #IF(%SHOWTAGCONTROL)
%ManagerName.Popup.AddItemEvent(' ',EVENT:Accepted,%SHOWTAGCONTROL)
    #ENDIF
    #RESUME
#ENDAT
#!
#!--------------------------------------------------------------------------
#! Tagging Kill
#!--------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),Priority(5600)
#INSERT(%TAGKILLGRP)
#ENDAT
#!--------------------------------------------------------------------------
#! Tag On / Off Control
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%TAGCONTROL,'Accepted'),LAST
  DO %TAGBROWSEPREFIX:TAGONOFF
#ENDAT
#!--------------------------------------------------------------------------
#! Tag All Control
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%TAGAllCONTROL,'Accepted'),LAST
  DO %TAGBROWSEPREFIX:TAGAll
#ENDAT
#!--------------------------------------------------------------------------
#! UnTag All Control
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%UNTAGALLCONTROL,'Accepted'),LAST
  DO %TAGBROWSEPREFIX:UNTAGALL
#ENDAT
#!--------------------------------------------------------------------------
#! Rev Tag Control
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%REVTAGCONTROL,'Accepted'),LAST
  DO %TAGBROWSEPREFIX:REVTAGALL
#ENDAT
#!--------------------------------------------------------------------------
#! Show Tag Control
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%SHOWTAGCONTROL,'Accepted'),LAST
  DO %TAGBROWSEPREFIX:SHOWTAG
#ENDAT
#!--------------------------------------------------------------------------
#! Tag Space Bar And Mouse Tagging
#!--------------------------------------------------------------------------
#AT(%ControlPostEventHandling,%BROWSECTRL,'NewSelection')
#INSERT(%TAGSPACEMOUSEGRP)
#ENDAT
#!--------------------------------------------------------------------------
#! Tag Space Bar
#!--------------------------------------------------------------------------
#AT(%BrowserMethodCodeSection,%TAGListInstance,'TakeKey','(),BYTE')
#IF(%TAGALLOWSPACEBAR)
#!IF Keycode() = SpaceKey
#!  RETURN ReturnValue
#!END
#ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#! Tag Space Bar
#!--------------------------------------------------------------------------
#AT(%ControlEventHandling,%Control,'AlertKey')  #!'PreAlertKey'
#IF(%TAGALLOWSPACEBAR)
IF Keycode() = SpaceKey
  #!DO %TAGBROWSEPREFIX:TAGONOFF
   POST(EVENT:Accepted,%TAGCONTROL)
    CYCLE
END
#ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#! Tagging Filter
#!--------------------------------------------------------------------------
#AT(%BrowserMethodCodeSection,%TAGListInstance,'ValidateRecord','(),BYTE'),Priority(6600),Where(%SHOWTAGCONTROL)
  #INSERT(%TAGQueueAccess,'GET',%TAGQUEUENAME,%TAGGACTQUEUEFIELDS)
  EXECUTE %TAGBROWSEPREFIX:TAGDISPSTATUS
     IF ERRORCODE() THEN %InstancePrefix:RecordStatus = RECORD:FILTERED END
     IF ~ERRORCODE() THEN %InstancePrefix:RecordStatus = RECORD:FILTERED END
  END
#ENDAT
#!--------------------------------------------------------------------------
#! Set Up Tag Display Char For Browse Queue
#!--------------------------------------------------------------------------
#AT(%BrowserMethodCodeSection,%TAGListInstance,'SetQueueRecord','()'),Priority(4500)  
#INSERT(%TAGSETTAGCHARGRP)
#ENDAT
#!--------------------------------------------------------------------------
#! Tagging Routines
#!--------------------------------------------------------------------------
#AT(%ProcedureRoutines)
#INSERT(%TAGCHECKTAGINGONOFFRTN)
#INSERT(%TAGCHECKTAGINGALLRTN)
#INSERT(%TAGCHECKUNTAGINGALLRTN)
#INSERT(%TAGCHECKREVTAGINGRTN)
#INSERT(%TAGCHECKSHOWTAGINGRTN)
#INSERT(%TAGFILESAVERTN)
#INSERT(%TAGFILERESTORERTN)
#ENDAT
#INCLUDE('TAGEXT.TPW')     #!EXTENSION TEMPLATES
#INCLUDE('TAGGRP.TPW')     #!GROUPS



      
